import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "moebius92.Handlers";

_G.SkirmishRaids = Turbine.PluginData.Load(Turbine.DataScope.Server, "SkirmishRaidTracker");
if type(_G.SkirmishRaids) ~= "table" then
	_G.SkirmishRaids = { };
end

moebius92.Handlers.AddChatHandler(
function(m)
	if string.sub(m, 1, 10) == "Completed:" then
		if string.sub(m, -8, -2) == " - Raid" then
			local name = Turbine.Gameplay.LocalPlayer.GetInstance():GetName();
			if _G.SkirmishRaids[name] == nil then
				_G.SkirmishRaids[name] = { };
			end
			_G.SkirmishRaids[name][string.sub(m, 12, -9)] = Turbine.Engine.GetLocalTime();
			Turbine.PluginData.Save(Turbine.DataScope.Server, "SkirmishRaidTracker", _G.SkirmishRaids);
		elseif string.sub(m, -7, -1) == " - Raid" then
			local name = Turbine.Gameplay.LocalPlayer.GetInstance():GetName();
			if _G.SkirmishRaids[name] == nil then
				_G.SkirmishRaids[name] = { };
			end
			_G.SkirmishRaids[name][string.sub(m, 12, -8)] = Turbine.Engine.GetLocalTime();
			Turbine.PluginData.Save(Turbine.DataScope.Server, "SkirmishRaidTracker", _G.SkirmishRaids);
		end
	end
end,
               Turbine.ChatType.Quest, nil);

SkirmishRaidTrackerCommand = class(Turbine.ShellCommand);

function SkirmishRaidTrackerCommand:Execute(command, arguments)
	local w = math.floor((Turbine.Engine.GetLocalTime() - (11 * 60 * 60)) / (7 * 24 * 60 * 60));

	for k1, v1 in pairs(_G.SkirmishRaids) do
		local found = false;

		for k2, v2 in pairs(v1) do
			local w1 = math.floor((v2 - (11 * 60 * 60)) / (7 * 24 * 60 * 60));

			if w == w1 then
				if not found then
					Turbine.Shell.WriteLine("");
					Turbine.Shell.WriteLine(k1 .. ":");
					found = true;
				end
				Turbine.Shell.WriteLine(k2);
			end
		end
	end
end

function SkirmishRaidTrackerCommand:GetShortHelp()
	return "Skirmish Raid Tracker";
end

skirmishRaidTrackerCommand = SkirmishRaidTrackerCommand();
Turbine.Shell.AddCommand('srt', skirmishRaidTrackerCommand);